import os
from Actions import *
from InterfaceGenerator_MM import *


def initRoot(groupList):
    global root

    for group in groupList:
        if group.isRoot.getValue()[1]==1:
            root=group  ## WE HAVE FOUND THE ROOT NODE OF THE TREE

def initFirstPageLists(groupList,commandList,stateVariableList):
    for group in groupList:
        if group.height.getValue()==1:
            tempGroupList.append(group)
    for stateVariable in stateVariableList:
        if stateVariable.height.getValue()==1:
            tempStateVariableList.append(stateVariable)
    for command in commandList:
        if command.height.getValue()==1:
            tempCommandList.append(command)
# Future work: Another for loop for listGroup


def createFirstPage(groupList,commandList,stateVariableList,fo):
    ### ALL NODES WHOSE HEIGHT IS 1
  
    fo.write("\n\n")
    fo.write("groupButtonList=list()\n")
    fo.write("stateVariableList=list()\n")
    fo.write("stateVariableEntryList=list()\n")
    fo.write("commandButtonList=list()\n")
    fo.write("backButton=None\n\n")
    #Future work:Another list for listGroup   

    ###Creating Group Buttons
     
    for group in groupList: 
       fo.write("groupButtonList.append(Button(app,text=\""+group.name.getValue()+"\",command=updatePageTo"+group.name.getValue()+"))\n")   
    fo.write("\n")

    for i in range(len(groupList)):
        fo.write("groupButtonList["+str(i)+"].pack()\n")

    ###Creating group buttons finished
    fo.write("\n")
    
    ###Creating StateVariables(Layer and text box)

    for i in range(len(stateVariableList)):
        fo.write("labelText"+str(i)+" =StringVar()\n")
        fo.write("labelText"+str(i)+".set(\"Enter the "+stateVariableList[i].name.getValue()+" value below\")\n")
    fo.write("\n")

    for i in range(len(stateVariableList)):
        fo.write("stateVariableList.append(Label(app,textvariable=labelText"+str(i)+"))\n")
        fo.write("stateVariableEntryList.append(Entry(app))\n")
    fo.write("\n")
    
    for i in range(len(stateVariableList)):
        fo.write("stateVariableList["+str(i)+"].pack()\n")
        fo.write("stateVariableEntryList["+str(i)+"].pack()\n")

    ###Creating StateVariables finished

    fo.write("\n")

    ###Creating Command Button

    for command in commandList: 
        fo.write("commandButtonList.append(Button(app,text=\""+command.name.getValue()+"\"))\n")
   
    fo.write("\n")

    for i in range(len(commandList)):
        fo.write("commandButtonList["+str(i)+"].pack()\n")

    fo.write("\n")

def updatePage(groupList,fo):
##Her group buttonu basildiginda bu fonksyon cagirilacak. parametre olarak subtree rootu gidecek. Cocuklari ekrana basilacak. createfirstpage de oldugu gibi sayfanin en altina back tusu koyulacak bu da backPage() fonksyonunu cagiracak.
    ###Tree traversal algoritm ve group kadar updatePage yaratilacak

    groupChildrenList=list()
    stateVariableChildrenList=list()
    commandChildrenList=list()
    
    for group in groupList:

        groupChildrenList=getGroupChildrenOfTheNode(group)
        stateVariableChildrenList=getStateVariableChildrenOfTheNode(group)
        commandChildrenList=getCommandChildrenOfTheNode(group)

        parent=getParentOfTheNode(group)

    	fo.write("def updatePageTo"+group.name.getValue()+"():\n")
    	fo.write(" for g in groupButtonList:\n")
    	fo.write("  g.destroy()\n")
    	fo.write(" for s in stateVariableList:\n")
    	fo.write("  s.destroy()\n")
    	fo.write(" for se in stateVariableEntryList:\n")
    	fo.write("  se.destroy()\n")
    	fo.write(" for c in commandButtonList:\n")
    	fo.write("  c.destroy()\n")

    	fo.write(" del groupButtonList[:]\n")
    	fo.write(" del stateVariableList[:]\n")
    	fo.write(" del stateVariableEntryList[:]\n")
    	fo.write(" del commandButtonList[:]\n")
  
    	fo.write("#Initialization of the new page\n\n")

        fo.write("#First delete the back button no matter page we are navigated\n")
        fo.write(" global backButton\n\n")

        fo.write(" if backButton!=None:\n")
        fo.write("  backButton.destroy()\n")
        fo.write("  backButton=None\n\n")

        ###Creating Group Buttons

        for children in groupChildrenList:
            fo.write(" groupButtonList.append(Button(app,text=\""+children.name.getValue()+"\",command=updatePageTo"+children.name.getValue()+"))\n")
        fo.write("\n")
	for i in range(len(groupChildrenList)):
            fo.write(" groupButtonList["+str(i)+"].pack()\n")
        ###Creating group buttons finished
    	fo.write("\n")
        ###Creating StateVariables(Layer and text box)
        for i in range(len(stateVariableChildrenList)):
            fo.write(" labelText"+str(i)+" =StringVar()\n")
            fo.write(" labelText"+str(i)+".set(\"Enter the "+stateVariableChildrenList[i].name.getValue()+" value below\")\n")
        fo.write("\n")

        for i in range(len(stateVariableChildrenList)):
            fo.write(" stateVariableList.append(Label(app,textvariable=labelText"+str(i)+"))\n")
            fo.write(" stateVariableEntryList.append(Entry(app))\n")
        fo.write("\n")
    
        for i in range(len(stateVariableChildrenList)):
            fo.write(" stateVariableList["+str(i)+"].pack()\n")
            fo.write(" stateVariableEntryList["+str(i)+"].pack()\n")
        ###Creating StateVariables finished

        fo.write("\n")
        ###Creating Command Button

        for command in commandChildrenList: 
            fo.write(" commandButtonList.append(Button(app,text=\""+command.name.getValue()+"\"))\n")
   
        fo.write("\n")

        for i in range(len(commandChildrenList)):
            fo.write(" commandButtonList["+str(i)+"].pack()\n")

        fo.write("\n")
        fo.write("\n")


        if group.height.getValue()!=0: ### Creating the Back button
            fo.write(" backButton=Button(app,text=\"Back\",command=updatePageTo"+parent.name.getValue()+")\n")
            fo.write(" backButton.pack(side=\'bottom\')\n") 




tempGroupList=list()
tempStateVariableList=list()
tempCommandList=list()
root=None

def start(groupList,commandList,stateVariableList):
    global root

    initRoot(groupList)



    fo=open("output.py","w")  ## Output.py is the output

    fo.write("import sys\n")
    fo.write("from Tkinter import *\n\n")

    updatePage(groupList,fo)

    fo.write("app=Tk()\n")
    fo.write("app.geometry('450x300+200+200')\n")
    fo.write("app.title(\""+root.name.getValue()+"\")\n")   ## The name of the root node is the title of the app

    initFirstPageLists(groupList,commandList,stateVariableList)

    createFirstPage(tempGroupList,tempCommandList,tempStateVariableList,fo)

    
    
    fo.write("app.mainloop()\n")

